﻿import mx.controls.*;
import mx.components.*;

class FindReplace{
	var conversionTable:Array;
	var original_conversionTable:Array;
	var flashCookie:SharedObject;
	//
	var original_ta:TextArea;
	var converted_ta:TextArea;
	//
	var test_pb:Button;
	var convert_pb:Button;
	var resetMapping_pb:Button;
	var deleteMapping_pb:Button;
	var saveMapping_pb:Button;
	var deleteSelMapping_pb:Button;	
	var addMapping_pb:Button;
	//
	var mapping_li:List;
	//
	var findWhat_ti:TextInput;
	var replaceWith_ti:TextInput;	
	
	//--------------------
	// (empty) constructor
	//--------------------
	public function FindReplace(){

	}
	
	//--------------------------
	// on load -- INITIALIZATION
	//--------------------------
	private function onLoad() {
		// buttons
		test_pb.addEventListener("click", this);
		convert_pb.addEventListener("click", this);
		resetMapping_pb.addEventListener("click", this);
		deleteMapping_pb.addEventListener("click", this);
		saveMapping_pb.addEventListener("click", this);
		deleteSelMapping_pb.addEventListener("click", this);
		addMapping_pb.addEventListener("click", this);
		//
		init();
	}
	
	//---------------
	// Initialization
	//---------------
	private function init():Void
	{
		original_conversionTable = [
					["â€”","—"],["â€“","–"],["Ã´","ô"],["Ã©","é"],["Ã¹","ù"],["Ã®","î"],["Ã­","í"],["Ã±","ñ"],["Ã","Á"],["Ã«","ë"],["Ã¥","å"],["Ã…","Å"],
					["Ã–","Ö"],["Ã£","ã"],["Ã¢","â"],["Ãµ","õ"],["Ãˆ","È"],["Ã¬","ì"],["Ã¤","ä"],["Ã¦","æ"],["Ã¸","ø"],["Ã¶","ö"],["Ã¼","ü"],["Ãš","Ú"],
					["Ã´","ô"],["Å¾","ž"],["Å¯","ů"],["Å™","ř"],["Å¡","š"],["Å˜","Ř"],["Åˆ","ň"],["Å ","Š"],["Å½","Ž"],["Å‘","ő"],["Å±","ű"],["Å«","ū"],
					["Å†","ņ"],["Å„","ń"],["Å‚","ł"],["Å›","ś"],["Å¼","ż"],["Åº","ź"],["Ä™","ę"],["Ä›","ě"],["Ä","č"],["Ä","ď"],["Ä—","ė"],["Ä","ā"],
					["Ä«","ī"],["Ä£","ģ"],["Ä“","ē"],["Ä·","ķ"],["Ä¼","ļ"],["Ä¢","Ģ"],["Ä‡","ć"],["Ä…","ą"],
					// Begin GREEK				   
					["Î•","Ε"],["Î½","ν"],["Î­","έ"],["Ï","ρ"],["Î³","γ"],["Îµ","ε"],["Î¹","ι"],["Î±","α"],["Î‘","Α"],["Ï‡","χ"],["Îº","κ"],["ÏŒ","ό"],
					["Ïƒ","σ"],["Ï„","τ"],["Î¬","ά"],["Î´","δ"],["Î¿","ο"],["Î¼","μ"],["Ï€","π"],["Î·","η"],["Î¯","ί"],["Ï‰","ω"],["Ï…","υ"],["Î¸","θ"],
					["Ï","ύ"],["Î£","Σ"],["Î»","λ"],["Ï‚","ς"],["Î®","ή"],["Î¤","Τ"],["ÏŽ","ώ"],["Ï†","φ"],["Î¾","ξ"],["Î”","Δ"],["Î²","β"],["ÏŠ","ϊ"],
					["Î ","Π"],["Î§","Χ"],["ÎŸ","Ο"],["Î›","Λ"],["Î—","Η"],["Îš","Κ"],["Î¶","ζ"],["Îš","Κ"],["Î","Ν"],["Ïˆ","ψ"],["Ï‹","ϋ"],["Î˜","Θ"],
					["ÎŒ","Ό"],["Îœ","Μ"],["Îˆ","Έ"],["Î’","Β"],["Î¥","Υ"],["Î“","Γ"]
					//  End GREEK
				   ];
		//
		conversionTable = original_conversionTable.slice(0,original_conversionTable.length);
		flashCookie = SharedObject.getLocal("fndRplMap");
		//
		if(flashCookie.data.mapping != null && flashCookie.data.mapping != undefined){
			conversionTable = flashCookie.data.mapping; // cast to Object to Array and overwrite coversionTable with mapping from cookie
			converted_ta.text = "INFO TRACE :"+newline+"Mapping retrieved from cookie";
		}
		else{
			converted_ta.text = "INFO TRACE :"+newline+"Loaded default mapping";
		}
		// call to fill up mapping list
		fillUpMappingList();	
	}
	
	//----------------------------
	// Catches button click events
	//----------------------------
	private function click(e:Object):Void
	{
		switch(e.target){
			case test_pb:
				insertTestText();
				break;
			case convert_pb:				
				convertText();
				break;
			case resetMapping_pb:
				resetMapping();
				break;
			case deleteMapping_pb:
				deleteMapping();
				break;
			case saveMapping_pb:
				saveMappingToCookie();
				break;
			case deleteSelMapping_pb:
				deleteSelectedMappings();
				break;
			case addMapping_pb:
				addMapping();
			default:
		}
	}
	
	//----------------
	// Run the replace
	//----------------
	public function convertText():Void
	{
		var nConversions:Number = conversionTable.length;
		var dirtyText:String = original_ta.text;
		var cleanText:String = "";
		//
		for(var i=0;i<nConversions;i++){
			var txtOld:String = conversionTable[i][0];
			var txtNew:String = conversionTable[i][1];
			while(dirtyText.indexOf(txtOld) > -1){
				var tmpAnte:String = dirtyText.substring(0, dirtyText.indexOf(txtOld));
				var tmpPost:String = dirtyText.substring((dirtyText.indexOf(txtOld)+txtOld.length), dirtyText.length);
				dirtyText = tmpAnte + txtNew + tmpPost;		
			}
		}
		//
		cleanText = dirtyText;
		//
		converted_ta.text = cleanText;
	}
	
	//-------------------------------------------------------------------
	// Test button click handler : inserts test data into first text area
	//-------------------------------------------------------------------
	public function insertTestText():Void
	{
		var nConversions:Number = conversionTable.length;
		var dirtyText:String = "";
		for(var i=0;i<nConversions;i++) dirtyText += i+":"+conversionTable[i][0]+newline;
		original_ta.text = dirtyText;
	}
	
	//------------------------------------------------------------
	// Click handler of save button, saves mapping to flash cookie
	//------------------------------------------------------------
	public function saveMappingToCookie():Void
	{
		flashCookie.data.mapping = conversionTable;
		flashCookie.flush();
	}

	//-----------------------
	// Reset the mapping list
	//-----------------------
	public function deleteMapping():Void
	{
		conversionTable = new Array();
		fillUpMappingList();
	}

	//---------------------------
	// Go back to default mapping
	//---------------------------
	public function resetMapping():Void
	{
		conversionTable = new Array();
		conversionTable = original_conversionTable.slice(0,original_conversionTable.length);
		//
		fillUpMappingList();	
	}

	//----------------------------------------
	// Check to avoid mapping the same twice !
	//----------------------------------------
	private function checkIfAlreadyMapped(str:String):Boolean
	{
		var nConversions:Number = conversionTable.length;
		for(var i=0;i<nConversions;i++) if(conversionTable[i][0] == str) return true;
	}

	//------------
	// Add mapping
	//------------
	public function addMapping():Void
	{
		var findWhat:String = findWhat_ti.text;
		var replaceWith:String = replaceWith_ti.text;
		if(findWhat == "" || findWhat == replaceWith) return; // do nothing
		if(checkIfAlreadyMapped(findWhat)){
			converted_ta.text = "ATTENTION"+newline+"Mapping you tried to add already exists!";
			return; // no duplicates !
		}
		var myMapping:Array = new Array();
		myMapping.push(findWhat);
		myMapping.push(replaceWith);
		// add to conversion table
		conversionTable.push(myMapping);
		fillUpMappingList();	
	}

	//-------------------------
	// Delete selected mappings
	//-------------------------
	private function deleteSelectedMappings():Void
	{
		var mySelections:Array = mapping_li.selectedIndices;
		if(mySelections.length == 0) return; // do nothing, no selection
		mySelections = mySelections.sort(Array.NUMERIC); // sort from low to high
		var nbSel:Number = mySelections.length; 
		for(var i:Number=nbSel;i>=0;i--){
			var index:Number = mySelections[i];
			conversionTable.splice(index,1); // remove from high to low to to keep indexes correct
		}
		//
		fillUpMappingList();	
	}

	//-------------------------------
	// Empty and re-fill mapping list
	//-------------------------------
	private function fillUpMappingList():Void
	{
		var nConversions:Number = conversionTable.length;
		mapping_li.removeAll();
		
		// fill up mapping list
		for(var i=0;i<nConversions;i++){
			var item:Object = {};
			item.label = conversionTable[i][0]+" >> "+conversionTable[i][1];
			item.data = conversionTable[i];
			mapping_li.addItem(item);
		}
	}
}
